<script setup lang="ts">
import { computed, reactive, watch } from 'vue';
import { useFormRules, useNaiveForm } from '@/hooks/common/form';
import { $t } from '@/locales';
import { AddRoleInfo, UpDateRoleInfo } from '@/service/api';

defineOptions({
  name: 'TodoworkOperateDrawer'
});

interface Props {
  /** the type of operation */
  operateType: NaiveUI.TableOperateType;
  /** the edit row data */
  rowData?: Api.SystemManage.Codes | null;
}

const props = defineProps<Props>();

interface Emits {
  (e: 'submitted'): void;
}

const emit = defineEmits<Emits>();

const visible = defineModel<boolean>('visible', {
  default: false
});

const { formRef, validate, restoreValidation } = useNaiveForm();
const { defaultRequiredRule } = useFormRules();

const title = computed(() => {
  const titles: Record<NaiveUI.TableOperateType, string> = {
    add: $t('page.manage.role.addRole'),
    edit: $t('page.manage.role.editRole')
  };
  return titles[props.operateType];
});

type Model = Pick<Api.PlanManage.Plan, 'PLAN_CODE' | 'PLAN_RELA_CODE'>;

const model: Model = reactive(createDefaultModel());

function createDefaultModel(): Model {
  return {
    PLAN_CODE: '',
    PLAN_RELA_CODE: ''
  };
}

type RuleKey = Exclude<keyof Model, 'roleDesc'>;

const rules: Record<RuleKey, App.Global.FormRule> = {
  PLAN_CODE: defaultRequiredRule,
  PLAN_RELA_CODE: defaultRequiredRule
};

// const roleId = computed(() => props.rowData?.id || -1);

// const isEdit = computed(() => props.operateType === 'edit');

function handleInitModel() {
  Object.assign(model, createDefaultModel());

  if (props.operateType === 'edit' && props.rowData) {
    Object.assign(model, props.rowData);
  }
}

function closeDrawer() {
  visible.value = false;
}

async function handleSubmit() {
  await validate();
  if (props.operateType === 'edit') {
    // 修改信息
    const delinfo = await UpDateRoleInfo(model);
    if (delinfo.response !== undefined) {
      if (delinfo.response.data.code === '0000') {
        window.$message?.success(delinfo.response.data.msg as string);
        closeDrawer();
        emit('submitted');
      }
    }
  } else {
    // 新增账户
    const delinfo = await AddRoleInfo(model);
    if (delinfo.response !== undefined) {
      if (delinfo.response.data.code === '0000') {
        window.$message?.success(delinfo.response.data.msg as string);
        closeDrawer();
        emit('submitted');
      }
    }
  }
}

watch(visible, () => {
  if (visible.value) {
    handleInitModel();
    restoreValidation();
  }
});
</script>

<template>
  <NDrawer v-model:show="visible" display-directive="show" :width="360">
    <NDrawerContent :title="title" :native-scrollbar="false" closable>
      <NForm ref="formRef" :model="model" :rules="rules">
        <NFormItem label="编码名称" path="PLAN_CODE">
          <NInput v-model:value="model.PLAN_CODE" :placeholder="$t('page.manage.role.form.roleName')" />
        </NFormItem>
        <NFormItem label="编码" path="PLAN_RELA_CODE">
          <NInput v-model:value="model.PLAN_RELA_CODE" :placeholder="$t('page.manage.role.form.roleCode')" />
        </NFormItem>
      </NForm>
      <template #footer>
        <NSpace :size="16">
          <NButton @click="closeDrawer">{{ $t('common.cancel') }}</NButton>
          <NButton type="primary" @click="handleSubmit">{{ $t('common.confirm') }}</NButton>
        </NSpace>
      </template>
    </NDrawerContent>
  </NDrawer>
</template>

<style scoped></style>
